import Actor from "./actor.js"

export default class Dvd extends Actor {
  constructor(game, x, y) {
    super(game)
    this.x = x
    this.y = y
    this.width = 80
    this.height = 50
    this.xVel = 2
    this.yVel = 2
    this.color = "#F69"
  }
  
  tick(dt) {
    if (this.x + this.xVel < 0) this.xVel = -this.xVel
    if (this.x + this.width + this.xVel > this.game.canvas.width) this.xVel = -this.xVel

    if (this.y + this.yVel < 0) this.yVel = -this.yVel
    if (this.y + this.height + this.yVel > this.game.canvas.height) this.yVel = -this.yVel

    this.x += this.xVel 
    this.y += this.yVel 
  }

  draw(ctx) {
    ctx.beginPath()
    ctx.fillStyle = this.color
    ctx.rect(this.x, this.y, this.width, this.height)
    ctx.fill()
    ctx.closePath()
  }
}
