export default class Event {
  constructor(name, action) {
    this.name = name
    this.action = action
    this.triggered = false
    this.triggeredThisFrame = false
  }

  trigger(object) {
    this.triggeredThisFrame = true
    if (!this.triggered) {
      this.triggered = true
      this.action(object)
    }
  }

  nextFrame() {
    this.triggered = this.triggeredThisFrame
    this.triggeredThisFrame = false
  }
}
